from enum import Enum
from abc import ABC, abstractmethod


class AbstractDispatcherConfig(ABC):
    """
    Abstract implementation of dispatcher config.
    Use this for create own configs.
    """
    @property
    @abstractmethod
    def event_enum(self) -> Enum:
        """
        Returns events enum.
        :return:
        """


class DispatcherConfig(AbstractDispatcherConfig):
    """
    Basic implementation of dispatcher config.
    """
    def __init__(self, event_enum: Enum):
        self._event_enum = event_enum

    @property
    def event_enum(self) -> Enum:
        return self._event_enum
